using System;
using System.Collections.Generic;
using System.Text;
using System.Text.RegularExpressions;

namespace D_RegularExpressions
{
    class RegularExpressions
    {
        static void Main(string[] args)
        {
            Regex pattern = new Regex("(a[0-9]+){2}");
            string[] inputs ={ "abacus", "aa", "a3b56a1","ba45a","a39bar"};
            Console.WriteLine("Evaluating regular expression {0}",pattern);
            foreach (string s in inputs) {
                if (pattern.IsMatch(s)) {
                    Console.WriteLine("String >>{0}<< matches", s);
                }
                else {
                    Console.WriteLine("String >>{0}<< does not match", s);
                }
            }
            MatchingEmails();
            Console.ReadLine();
            SplitExample();
            Console.ReadLine();
            ReplaceExample();
            Console.ReadLine();
        }
        static void MatchingEmails()
        {
            Regex emailPattern = new Regex(@"^[a-zA-Z][a-zA-Z0-9_\.-]*[a-zA-Z0-9]@[a-zA-Z0-9][a-zA-Z0-9_\.-]*[a-zA-Z0-9]\.[a-zA-Z][a-zA-Z\.]*[a-zA-Z]$");
            string[] testAddresses = {
				"23@foo.com",
				"a.@foo.com",
				"a-a@foo.com",
				"a_a@foo.com",
				" b@foo.c1m"
			};
            Console.WriteLine("Checking conformance to email format using regex {0}", emailPattern);
            foreach (string s in testAddresses)
            {
                if (emailPattern.IsMatch(s))
                {
                    Console.WriteLine("This is a valid email address: {0}", s);
                }
                else
                {
                    Console.WriteLine("This is not a valid email address: {0}", s);
                }
            }
        }
        static void SplitExample()
        {
            Regex separator = new Regex(@"[ ,;:]+");
            char[] delimiters = { ' ', ',', ';', ':' };
            string example = "A nice, simple, short example";
            Console.WriteLine("String splitting");
            foreach (string s in example.Split(delimiters))
            {
                Console.WriteLine("  >>{0}<<", s);
            }
            Console.WriteLine("Regex splitting");
            foreach (string s in separator.Split(example))
            {
                Console.WriteLine("  >>{0}<<", s);
            }
        }
        static void ReplaceExample()
        {
            Regex num = new Regex("[0-9]+");
            string input = "Some numbers here 12 83.57 -13 000";
            Console.WriteLine("The input is {0}", input);
            Console.WriteLine("The output is {0}", num.Replace(input,"0"));
        }
    }
}
